Summary: The Berkeley DB database library (version 4) for C
Name: db4
Version: 4.7.25
Release: 1
Source0: http://download.oracle.com/berkeley-db/db-%{version}.tar.gz
Source1: http://download.oracle.com/berkeley-db/db.1.85.tar.gz
Source2: db.1.85-aix-patch.tar.gz
Patch0: http://www.oracle.com/technology/products/berkeley-db/db/update/4.7.25/patch.4.7.25.1
Patch1: http://www.oracle.com/technology/products/berkeley-db/db/update/4.7.25/patch.4.7.25.2
Patch2: http://www.oracle.com/technology/products/berkeley-db/db/update/4.7.25/patch.4.7.25.3
Patch10: http://www.oracle.com/technology/products/berkeley-db/db/update/1.85/patch.1.1
Patch11: http://www.oracle.com/technology/products/berkeley-db/db/update/1.85/patch.1.2
Patch12: http://www.oracle.com/technology/products/berkeley-db/db/update/1.85/patch.1.3
Patch13: http://www.oracle.com/technology/products/berkeley-db/db/update/1.85/patch.1.4
URL: http://www.oracle.com/database/berkeley-db/
License: BSD
Group: System Environment/Libraries
Obsoletes: db1, db2, db3
Provides: db1, db2, db3
BuildRequires: perl, libtool, ed, patch, tcl-devel >= 8.4.4
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

%define _libdir64 %{_prefix}/lib64

%description
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. The Berkeley DB includes B+tree, Extended
Linear Hashing, Fixed and Variable-length record access methods,
transactions, locking, logging, shared memory caching, and database
recovery. The Berkeley DB supports C, C++, Java, and Perl APIs. It is
used by many applications, including Python and Perl, so this should
be installed on all systems.

The library is available as 32-bit and 64-bit.


%package cxx
Summary: The Berkeley DB database library (version 4) for C++
Group: System Environment/Libraries

%description cxx
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. The Berkeley DB includes B+tree, Extended
Linear Hashing, Fixed and Variable-length record access methods,
transactions, locking, logging, shared memory caching, and database
recovery. The Berkeley DB supports C, C++, Java, and Perl APIs. It is
used by many applications, including Python and Perl, so this should
be installed on all systems.

The library is available as 32-bit and 64-bit.


%package utils
Summary: Command line tools for managing Berkeley DB (version 4) databases
Group: Applications/Databases
Requires: %{name} = %{version}-%{release}
Obsoletes: db1-utils, db2-utils, db3-utils
Provides: db1-utils, db2-utils, db3-utils

%description utils
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. Berkeley DB includes B+tree, Extended
Linear Hashing, Fixed and Variable-length record access methods,
transactions, locking, logging, shared memory caching, and database
recovery. DB supports C, C++, Java and Perl APIs.


%package devel
Summary: C development files for the Berkeley DB (version 4) library
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Obsoletes: db1-devel, db2-devel, db3-devel
Provides: db1-devel, db2-devel, db3-devel

%description devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. This package contains the header files,
libraries, and documentation for building programs which use the
Berkeley DB.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "xlc_r -q64" or "gcc -maix64".


%package tcl
Summary: Development files for using the Berkeley DB (version 4) with tcl
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: tcl-devel

%description tcl
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. This package contains the libraries
for building programs which use the Berkeley DB in Tcl.


%prep
export PATH=/opt/freeware/bin:$PATH
%setup -q -n db-%{version} -a 1
gzip -dc %{SOURCE2} | tar xvf -
%patch0 -p0 -b .sequence
%patch1 -p0 -b .lock
%patch2 -p0 -b .lock

cd db.1.85/PORT/aix.5.1
%patch10 -p0 -b .1.1
cd ../..
%patch11 -p0 -b .1.2
%patch12 -p0 -b .1.3
%patch13 -p0 -b .1.4
cd ..

mkdir -p ../64bit
cp -r * ../64bit/
mv ../64bit .


%build
# first build the 64-bit version
cd 64bit
export OBJECT_MODE=64
export CC=cc

# Build the old db-185 libraries
cd db.1.85/PORT/aix.5.1
make OORG="$CFLAGS"
cd ../../..

# Static link db_dump185 with old db-185 libraries.
cd build_unix
cc -I../db.1.85/PORT/aix.5.1/include -I../db.1.85/PORT/aix.5.1 -o db_dump185 ../db_dump185/db_dump185.c ../db.1.85/PORT/aix.5.1/libdb.a 
cd ..

export CC="xlc_r"
export CXX="xlC_r"

cd build_unix
../dist/configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --enable-shared --disable-static \
    --enable-compat185 --enable-dump185 \
    --enable-tcl --with-tcl=%{_libdir} \
    --enable-cxx \
    --disable-java \
    --enable-pthread_api \
    --enable-test

touch db_dump185.lo
touch db_dump185

make

cd ../..

# now build the 32-bit
export OBJECT_MODE=32
export CC=cc

# Build the old db-185 libraries
cd db.1.85/PORT/aix.5.1
make OORG="$CFLAGS"
cd ../../..

# Static link db_dump185 with old db-185 libraries.
cd build_unix
cc -I../db.1.85/PORT/aix.5.1/include -I../db.1.85/PORT/aix.5.1 -o db_dump185 ../db_dump185/db_dump185.c ../db.1.85/PORT/aix.5.1/libdb.a 
cd ..

export CC=xlc_r
export CXX=xlC_r

cd build_unix
../dist/configure \
    --prefix=%{_prefix} \
    --enable-shared --disable-static \
    --enable-compat185 --enable-dump185 \
    --enable-tcl --with-tcl=%{_libdir} \
    --enable-cxx \
    --disable-java \
    --enable-pthread_api \
    --enable-test

touch db_dump185.lo
touch db_dump185

make


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

export OBJECT_MODE=64
cd 64bit/build_unix
make DESTDIR=${RPM_BUILD_ROOT} install

for f in ${RPM_BUILD_ROOT}%{_bindir}/* ; do
    mv ${f} ${f}_64
done
cd ../..

export OBJECT_MODE=32
cd build_unix
make DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

# move the header files to a subdirectory, in case we're deploying on a
# system with multiple versions of DB installed.
mkdir -p ${RPM_BUILD_ROOT}%{_includedir}/%{name}
mv ${RPM_BUILD_ROOT}%{_includedir}/*.h ${RPM_BUILD_ROOT}%{_includedir}/%{name}/

# Create symlinks to includes so that "use <db.h> and link with -ldb" works.
for i in db.h db_cxx.h db_185.h ; do
    ln -s %{name}/${i} ${RPM_BUILD_ROOT}%{_includedir}
done

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system)
%doc LICENSE README
%{_libdir}/libdb-*.so
%{_libdir64}/libdb-*.so
%{_libdir}/libdb.so
%{_libdir64}/libdb.so
/usr/lib/libdb-*.so
/usr/lib64/libdb-*.so
/usr/lib/libdb.so
/usr/lib64/libdb.so


%files cxx
%defattr(-,root,system)
%{_libdir}/libdb_cxx*.so
%{_libdir64}/libdb_cxx*.so
/usr/lib/libdb_cxx*.so
/usr/lib64/libdb_cxx*.so


%files utils
%defattr(-,root,system)
%doc docs/utility
%{_bindir}/*
/usr/bin/*


%files devel
%defattr(-,root,system)
%doc docs/api_c docs/api_cxx docs/api_tcl docs/index.html
%doc docs/ref docs/images
%doc examples_c examples_cxx
%{_libdir}/*.la
/usr/lib/*.la
%{_includedir}/db.h
%{_includedir}/db_185.h
%{_includedir}/db_cxx.h
/usr/include/db.h
/usr/include/db_185.h
/usr/include/db_cxx.h
%dir %{_includedir}/%{name}
%dir /usr/include/%{name}
%{_includedir}/%{name}/db.h
%{_includedir}/%{name}/db_185.h
%{_includedir}/%{name}/db_cxx.h
/usr/include/%{name}/db.h
/usr/include/%{name}/db_185.h
/usr/include/%{name}/db_cxx.h


%files tcl
%defattr(-,root,system)
%{_libdir}/libdb_tcl*.so


%changelog
* Wed Mar 19 2009 Michael Perzl <michael@perzl.org> - 4.7.25-1
- first version for AIX V5.1 and higher
